      subroutine sunglasses(nopt,iobj,isens)
!     subroutine sunglasses(iclb,nopt)
!     !  !         !         !         !         !         !         ! !
c	Main program for the optimisation and uncertainty analysis

!!    iobj         |none          |number of objective functions
!!    obj(:)       |none          |values of the objective functions
!!    iclb         |none          |method to form GOC out of objective functions
!!    icalpar(:,:) |none          |objective functions codes of OBJMET.DAT
!!    iitel        |none          |number of simulation run
!!    iinr(:)      !              |number of HRUs to change for parameter (:)
!!    inrhru(:,:)  |none          |list of HRU numbers to change  

c     AVG



c  THIS IS THE MAIN PROGRAM CALLING SUBROUTINES sunglasin, parasolopt, parasolunc, sunglasunc
!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
      integer icalpar(4,iobj), iobj, isenspar(4,isens),iprob, imet(nopt)
      integer  iiname(nopt), iinr(nopt), inrhru(nopt,2000),nobs(iobj)
	integer icalml, igoc
      real*8 a(100), bbound(2,nopt), sensw(isens), omin(iobj),
     *	bestf, varobj(iobj), varval(iobj), avval(iobj)
      real*8  xxo(nopt)
      character*10 pcntrl,deflt,usrsp, parname(nopt)
      character*8 reduc,initl,ysflg,noflg
      data deflt/' DEFAULT  '/
      data usrsp/'USER SPEC.'/
      data ysflg/'YES '/
      data noflg/'NO  '/
      common /iopar/ in,iprii


	 character*4 fmnname(40), fmxname(40), tt
        data fmnname /'mn01','mn02','mn03','mn04','mn05','mn06','mn07',
     &'mn08','mn09','mn10','mn11','mn12','mn13','mn14','mn15','mn16',
     &'mn17','mn18','mn19','mn20','mn21','mn22','mn23',
     &'mn24','mn25','mn26','mn27','mn28','mn29','mn30','mn31','mn32',
     &'mn33','mn34','mn35','mn36','mn37','mn38','mn39','mn40'/
       data fmxname /'mx01','mx02','mx03','mx04','mx05','mx06','mx07',
     &'mx08','mx09','mx10','mx11','mx12','mx13','mx14','mx15','mx16',
     &'mx17','mx18','mx19','mx20','mx21','mx22','mx23',
     &'mx24','mx25','mx26','mx27','mx28','mx29','mx30','mx31','mx32',
     &'mx33','mx34','mx35','mx36','mx37','mx38','mx39','mx40'/

	
      open(18010,file='changepar.dat',status='old')
      open(18009,file='sunglasses.in',status='old')
      open(18011,file='sunglasses.out',status='unknown')
      open(18012, file='sceobjf.out')
	open(18014, file='respons.out')
      open(18013, file='scepar.out')
      open(18018, file='sceparobj.dat')
	open(18019, file='scegoc.out')
	open(18020, file='bestpar.out')
	open(19014, file='paruncbias.out')
      open(19013, file='pargoodpar.out')
      open(19012, file='paruncobjf.out')
	open(18021, file='sunglasbias.out')
      open(18024, file='sunglasuncbias.out')
      open(19022, file='sunglasuncobjf.out')
	open(19023, file='sunglasmet.in')
		iprii=18011

	call readchangepar(bbound,nopt,iiname,iinr, inrhru,imet,parname)
	call readmetfiles(iobj,calw, icalpar,isenspar,sensw,
     *	isens)
	call parasolin(maxn,kstop,pcento,iseed,nopt,iobj,npt,
     &  nintval,igoc,ngs,npg,nps,nspl,istat, iprob)

	call countobs(nobs,iobj, icalpar,avval,varval)
	write(18011, *) '# observations |average   |variance    '
	do ii=1,iobj
	write(18011,*) ii, nobs(ii), avval(ii),varval(ii)
	end do
	ipr=0
	icd=3
c	go to 66
c	go to 67
c	calling subroutine to optimise for all the objective functions


c      call parasolopt(bbound,nopt,maxn,kstop,pcento,iseed,
c     *iiname, ngs,npg,nps,nspl,
c     *iniflg, iinr, inrhru,iobj, igoc,icalpar, 
c     *isens, sensw, isenspar,bestf,icalml, imet,omin,nobs,npt,i
c    * ,istat, iprob,varval)
	write(18011, *)
	write(18011, *) '*** AUTOCALIBRATION SUCCESSFULLY ENDED ***'
	write(18011, *)
67	continue

      call parasolopt(nopt,iobj,isens, npt,icd,ngs,npg,nps,nspl,
     *	maxn,kstop,pcento,iseed,igoc,icalml,iiname, bbound,
     * iinr, inrhru, icalpar, sensw, isenspar,
     *bestf, imet,omin,nobs,varval,iprob,istat)

	close(19013)
      open(19013, file='SGgoodpar.out')

	call sunglasunc(iobj,igoc,nopt,icalml, bbound,
     *	parname, ntot,omin,nobs,nintval,
     *    iiname, inrhru, iinr,
     * isens,icalpar, isenspar, sensw, imet)
      close(18011)
      close(18012)
      close(18013)
	close(18014)
      close(18016)
	close(18017)
	close(18018)
	close(18019)
	close(18020)
      close(19012)
      close(19013)
	close(19014)
	close(19023)
	close(19022)
66	continue
	return
	end

c  END OF THE MAIN PROGRAM
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	subroutine sunglasunc(iobj,igoc,nopt,icalml,bbound,
     *	parname, ntot,omin,nobs,m,iiname, inrhru, iinr,
     *isens,icalpar, isenspar, sensw, imet)
	character*10 parname(iobj)
c	calculates uncertainty
c	written by Ann van Griensven - University of California Riverside, april 2003


      real*8  sensw(isens), objfmin,objflim

	real*8 varobj(iobj), oflim(iobj),vobj(iobj),vresp(isens)
	real*8 parmn(nopt),parmx(nopt), bbound(2,nopt),vpar(nopt)
	real*8 objmx(iobj),respmn(isens),respmx(isens)
	real*8 respmng(isens),respmxg(isens),ff,omin(iobj)
	real*8 parr(nopt),objr(iobj),respr(isens), xp(nopt), yp(nopt)
	real*8 objgmx(iobj), objgmn(iobj),goc(icalml)
	real*8 biasmax(iobj),biasmin(iobj),vbias(iobj), vofsg(iobj,2)		
	integer isenspar(4,isens), imet(nopt)
	integer  m,ntot,igoc, itest(iobj), iofsg(iobj)
	integer  iiname(nopt), iinr(nopt), inrhru(nopt,2000),nobs(iobj)
	integer iobj,nopt,isens,icalml,icalpar(4,iobj)
	integer ipg(nopt,21),ipb(nopt,21),ipp(nopt), ind(icalml)

	vofsg=0.
602   continue
	read(19023,19023,end=601) j,vofsg(j,1),vofsg(j,2)
19023	format (i5,2f10.3)
	go to 602
601	continue

	close(18023)

	write(18011, *)
	write(18011, *)
	write(18011, *) '*** UNCERTAINTY ANALYSIS RESULT ***'
	write(18011, *)
	
	write(18011, *) 'Results using SUNGLASSES'
	rewind(18018)
	rewind(18014)
	do j=1,icalml
	read(18018,18) ik,ii,(vpar(kk),kk=1,nopt),goc(j)

	end do
	call sorteer6(goc,ind,icalml)
	itest=0
	ji=0
	biasmax=-1.e10
	biasmin=1.e10
441	continue
	ji=ji+1
	ialltest=1
	rewind(18021)
	do ii=1,ind(ji)
	read(18021,5)
	end do
	read(18021,5) ik,(vbias(kk), kk=1,iobj)	
		do m=1,iobj
		biasmax(m)=max(biasmax(m),vbias(m))
	    biasmin(m)=min(biasmin(m),vbias(m))
	   end do
		do i=1,iobj
		 if (biasmin(i).lt.vofsg(i,1).and.biasmax(i).gt.vofsg(i,2)) 
     *		itest(i)=1
	    ialltest=ialltest*itest(i)
	    end do
	if(ji.eq.icalml) go to 442
	if(ialltest.ne.1) go to 441

	objflim=goc(ji)


	objgmx=-1.e10
	objmx=-1.e10
	
	respmxg=-1.e10
	respmx=-1.e10
	omin=1.e10
	objgmn=1.e10
	respmn=1.e10
	respmng=1.e10
	parmn=1.e10
	parmx=-1.e10
	islc=0

	write(*,*) 'objective function limit',objflim
	write(18011,*) 'objective function limit',objflim	
	write(18011,*) 'maximum biases'
	write(18011,*) (biasmax(m),m=1,iobj)	
	write(18011,*) 'minimum biases'
	write(18011,*) (biasmin(m),m=1,iobj)
	do j=1,nopt
	parmn(j)=bbound(2,j)
	parmx(j)=bbound(1,j)
	end do



	rewind(18014)
	rewind(18012)
      rewind(18018)

	read(18012,*)
	do i=1,icalml


		read(18012,5) ik,(vobj(kk), kk=1,iobj)
		read(18018,18) ik,ii,(vpar(kk),kk=1,nopt),t
			read(18014,5, end=66) ik,(vresp(kk), kk=1,isens)

			do j=1,isens
			respmx(j)=max(respmx(j),vresp(j))
			respmn(j)=min(respmn(j),vresp(j))
			end do
66	continue
				do j=1,iobj
			omin(j)=min(omin(j),vobj(j))
			objmx(j)=max(objmx(j),vobj(j))
			end do
		if (t/objflim.le.1.01) then
		do j=1,nopt
		parmn(j)=min(parmn(j),vpar(j))
		parmx(j)=max(parmx(j),vpar(j))
		end do
			do j=1,iobj
		    objgmn(j)=min(objgmn(j),vobj(j))
			objgmx(j)=max(objgmx(j),vobj(j))
			end do
			write(19012,5) i,(vobj(kk), kk=1,iobj)

			write(19013,5) i,(vpar(kk),kk=1,nopt)
	if (isens.gt.0) then
			write(19014,5) i,(vresp(kk), kk=1,isens)
			do j=1,isens
			respmxg(j)=max(respmxg(j),vresp(j))
			respmng(j)=min(respmng(j),vresp(j))
			end do
	end if
			do j=1,nopt
			parmx(j)=max(parmx(j),vpar(j))
			parmn(j)=min(parmn(j),vpar(j))
		    ip=int((vpar(j)-bbound(1,j))*20./(bbound(2,j)-bbound(1,j)))
			ipg(j,ip+1)=ipg(j,ip+1)+1
			ipg(j,21)=ipg(j,21)+1
			end do	
			islc=islc+1
			end if
	end do
	do j=1,nopt
	parr(j)=(parmx(j)-parmn(j))*100./(bbound(2,j)-bbound(1,j))
	end do
	do j=1,isens
	respr(j)=(respmxg(j)-respmng(j))*100./(respmx(j)-respmn(j))
	end do


	write(18011,*)'*****statistics of selected space  *****'
	write(18011,*)'       *****  SUNGLASSES *****' 
	write(18011,*) ' Number of observations = ',nobs 
	write(18011,*) ' Number of free parameters = ',nopt
	write(18011,*) ' Limit on global objective function = ', objflim

	write(18011,*) ' number of selections', islc
	write(*,*) ' number of selections', islc
	write(18011,*)

	write(18011,*)'minimum parameter values'
	write(18011,6) (parmn(kk), kk=1,nopt)
	write(18011,*)'maximum parameter values'
	write(18011,6) (parmx(kk), kk=1,nopt)
	write(18011,*)'percentage of range '
	write(18011,7) (parr(kk), kk=1,nopt)
	write(18011,*)
	write(18011,*) 'mimimum objective function values'
	write(18011,6) (objgmn(kk), kk=1,iobj)
	write(18011,*) 'maximum objective function values'
	write(18011,6) (objgmx(kk),kk=1,iobj)	
	write(18011,*)
	write(18011,*)'minimum output values'
	write(18011,6) (respmng(kk),kk=1,isens)
	write(18011,*)'maximum output values'
	write(18011,6) (respmxg(kk),kk=1,isens)
	write(18011,*)'percentage of range'
	write(18011,7) (respr(kk),kk=1,isens)
	go to 111
442	continue
      write(18011,*) 'sunglasses couldnt make any selection'
	write(18011,*) 'maximum biases'
	write(18011,6) (biasmax(m),m=1,iobj)	
	write(18011,*) 'minimum biases'
	write(18011,6) (biasmin(m),m=1,iobj)
	write(18011,*) (itest(m),m=1,iobj)
7	format(5x,100f12.5)
6	format(5x,100e12.5)
5	format(i5,100e12.5)
18	format(2i5,100e12.5)
111	continue
	return
	end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c===================================================================
      subroutine sorteer6(arr,ind,len)

      integer len, lenn, ind(len), ihelp1, ihelp2
       real*8 arr(len), help1, help2
	do ii=1,len
	ind(ii)=ii
	end do
	  lenn=len
        do ii=1,len
         lenn=lenn-1
         help1=arr(1)
	 ihelp1=ind(1)
          do jj=1,lenn
		  ihelp1=ind(jj)
	      ihelp2=ind(jj+1)
            help1=arr(jj)
            help2=arr(jj+1)
            if (help2.lt.help1) then
            arr(jj)=help2
            arr(jj+1)=help1
	      ind(jj)=ihelp2
	      ind(jj+1)=ihelp1
          end if
          end do
          end do

c  END OF SUBROUTINE SORT
      return
      end
c
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine sunglasrerun(nopt,iobj,isens)
!     !  !         !         !         !         !         !         ! !
c	Main program for the optimisation and uncertainty analysis

!!    iobj         |none          |number of objective functions
!!    obj(:)       |none          |values of the objective functions
!!    iclb         |none          |method to form GOC out of objective functions
!!    icalpar(:,:) |none          |objective functions codes of OBJMET.DAT
!!    iitel        |none          |number of simulation run
!!    iinr(:)      !              |number of HRUs to change for parameter (:)
!!    inrhru(:,:)  |none          |list of HRU numbers to change  

c     AVG



c  THIS IS THE MAIN PROGRAM CALLING SUBROUTINES sunglasin, parasolopt, parasolunc, sunglasunc
!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
      integer icalpar(4,iobj), iobj, isenspar(4,isens),iprob, imet(nopt)
      integer  iiname(nopt), iinr(nopt), inrhru(nopt,2000),nobs(iobj)
	integer icalml, igoc
      real*8 a(100), bbound(2,nopt), sensw(isens), omin(iobj),
     *	bestf, varobj(iobj), vobj(iobj), vrval(iobj), avval(iobj)
      real*8  xxo(nopt)
      character*10 pcntrl,deflt,usrsp, parname(nopt)
      character*8 reduc,initl,ysflg,noflg
      data deflt/' DEFAULT  '/
      data usrsp/'USER SPEC.'/
      data ysflg/'YES '/
      data noflg/'NO  '/

	 character*4 fmnname(40), fmxname(40), tt
        data fmnname /'mn01','mn02','mn03','mn04','mn05','mn06','mn07',
     &'mn08','mn09','mn10','mn11','mn12','mn13','mn14','mn15','mn16',
     &'mn17','mn18','mn19','mn20','mn21','mn22','mn23',
     &'mn24','mn25','mn26','mn27','mn28','mn29','mn30','mn31','mn32',
     &'mn33','mn34','mn35','mn36','mn37','mn38','mn39','mn40'/
       data fmxname /'mx01','mx02','mx03','mx04','mx05','mx06','mx07',
     &'mx08','mx09','mx10','mx11','mx12','mx13','mx14','mx15','mx16',
     &'mx17','mx18','mx19','mx20','mx21','mx22','mx23',
     &'mx24','mx25','mx26','mx27','mx28','mx29','mx30','mx31','mx32',
     &'mx33','mx34','mx35','mx36','mx37','mx38','mx39','mx40'/

	

      open(18010,file='sunglasses.in',status='old')
      open(18011,file='sunglasses.out',status='unknown')
      open(18012, file='sceobjf.out')
	open(18014, file='respons.out')
      open(18013, file='scepar.out')
      open(18018, file='sceparobj.dat')
	open(18019, file='scegoc.out')
	open(18020, file='bestpar.out')
	open(19014, file='paruncbias.out')
      open(19013, file='pargoodpar.out')
      open(19012, file='paruncobjf.out')
	open(18021, file='sunglasbias.out')
      open(18024, file='sunglasuncbias.out')
      open(19022, file='sunglasuncobjf.out')
	open(19023, file='sunglasmet.in')
	
	call readchangepar(bbound,nopt,iiname,iinr, inrhru,imet,parname)
	call readmetfiles(iobj,calw, icalpar,isenspar,sensw,
     *	isens)

	call parasolin(maxn,kstop,pcento,iseed,nopt,iobj,npt,
     &  nintval,igoc,ngs,npg,nps,nspl, istat, iprob)
	call countobs(nobs,iobj, icalpar,avval,vrval)
	write(18011, *) '# observations |average   |variance    '
	do ii=1,iobj
	write(18011,*) ii, nobs(ii), avval(ii),vrval(ii)
	end do
	ipr=0
	icd=3
c	go to 66
c	go to 67
c	calling subroutine to optimise for all the objective functions


	write(18011, *)
	write(18011, *) '*** AUTOCALIBRATION SUCCESSFULLY ENDED ***'
	write(18011, *)
67	continue

	omin=1.e10
	rewind(18012)
	icalml=0
	read(18012,*)
1	read(18012,5,end=3) ik,(vobj(kk), kk=1,iobj)
	do kk=1,iobj
	omin(kk)=min(omin(kk),vobj(kk))
	end do
	icalml=icalml+1
	go to 1 
3     continue

5     format(1i5,100e12.5)


	call parasolunc(iobj,igoc,nopt,icalml,istat, iprob,bbound,
     *	parname, ntot,omin,nobs,nintval, iiname, inrhru, iinr,
     *    isens,icalpar, isenspar, sensw, imet)


	close(19013)
      open(19013, file='SGgoodpar.out')

	call sunglasunc(iobj,igoc,nopt,icalml, bbound,
     *	parname, ntot,omin,nobs,nintval,
     *    iiname, inrhru, iinr,
     * isens,icalpar, isenspar, sensw, imet)
      close(18011)
      close(18012)
      close(18013)
	close(18014)
      close(18016)
	close(18017)
	close(18018)
	close(18019)
	close(18020)
      close(19012)
      close(19013)
	close(19014)
	close(19023)
	close(19022)
66	continue
	return
	end

c  END OF THE MAIN PROGRAM
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
