      subroutine writeswatfilemain
!     !  !         !         !         !         !         !         ! !
c	Main program for the sensitivity analysis

!!    iobj         |none          |number of objective functions
!!    obj(:)       |none          |values of the objective functions
!!    iclb         |none          |method to form GOC out of objective functions
!!    icalpar(:,:) |none          |objective functions codes of CALMET.DAT
!!    iitel        |none          |number of simulation run
!!    iinr(:)      !              |number of HRUs to change for parameter (:)
!!    inrhru(:,:)  |none          |list of HRU numbers to change  

c     AVG

c
c  THIS IS THE MAIN PROGRAM CALLING SUBROUTINES SENSIN AND RUNSENS



c  THIS IS THE MAIN PROGRAM CALLING SUBROUTINES SENSIN AND RUNSENS
!     !  !         !         !         !         !         !         ! !
      real*8 bbound(2,200), calw(40), sensw(200),dt, xxo(200),obj(40)
      integer iinr(200), iiname(200), isens, imet(200)
      integer inrhru(200,2000), iobj, nintval, iseed
      integer icalpar(4,40), nopt, isenspar(4,100)
	character*7 swatfilen
c

      open(18010,file='batchin.dat',status='old')
      open(18011,file='batchout.dat',status='unknown')
      open(18012, file='batchobjf.out')
      open(18013, file='senspar.out')
      open(18015, file='batchpar.dat')
	open(18014, file='batchrespons.out')
      open(18016, file='objmet.dat')
	open(18017, file='responsmet.dat')
	open(18018, file='swatfilenames.prn')	
      open(18019, file='mcin.dat')			
	call batchin(bbound,nopt,
     & iiname,iinr, inrhru,iobj,
     & calw, icalpar,isenspar,sensw,isens, imet)
	read(18019,19) iseed, initel, iendtel
19	format(3i10)
	ipr=0
	icd=0
	do iitel=initel,iendtel
	do ii=1,nopt
	xxo(ii)= bbound(1,ii)+(bbound(2,ii)-bbound(1,ii))*ran(iseed)
	end do
	write(18015,8013) iitel, (xxo(ii), ii=1,nopt)
8013    format(i5, 100e12.5)
	read(18018, 7) swatfilen
	open (18019,file=swatfilen)
      call rerun(xxo, nopt,iiname, inrhru, iinr, iitel, imet,ipr)
      call objfunctn(obj, iobj, icalpar, iitel,icd)
	call response(sensw, isens, isenspar, iitel)
	call writeswatfile
	close(18019)
	end do
4	continue	
7	format(a7)
	close(18010)
      close(18011)
      close(18012)
      close(18013)
	close(18014)
	close(18015)
      close(18016)
	close(18017)

c  END OF THE BATCH ROUTINE
      return
	end

c==================================================================
       subroutine writeswatfile

!!    ~ ~ ~ PURPOSE ~ ~ ~
!!    write swatoutputs to files

!!    ~ ~ ~ INCOMING VARIABLES ~ ~ ~
!!    name         |units         |definition
!!    ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
!!    iobj         |none          |number of objective functions
!!    nobs(:)       |none         |number of observations
!!    icalpar(:,:) |none          |objective functions codes of OBJk_annaMET.DAT
!!    iitel        |none          |number of simulation run
!!    ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
!!    ~ ~ ~ OUTGOING VARIABLES ~ ~ ~
!!    name        |units         |definition
!!    ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
!!    obj(:)       |none          |values of the objective functions
!!    ffz(:)       |none          |transformed objectif function
!!    ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~

!!    ~ ~ ~ LOCAL DEFINITIONS ~ ~ ~
!!    name        |units         |definition
!!    ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~
!!    ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~ ~

!!    ~ ~ ~ SUBROUTINES/FUNCTIONS CALLED ~ ~ ~

		implicit real*8 (a-h,o-z)
        INTEGER yout, dagout, ydat, dagdat, daysout, daysdat, hdat, hout
        real*8 calouttot(22), xout(14)

c  mean sqare function
c  
	rewind(8001)
	rewind(8002)
	rewind(8003)
	rewind(8004)
	rewind(8005)

47	continue
      read(8001,5000, end=60)yout, dagout, hout,(calouttot(ki), ki=1,22)
	  xout(1)=calouttot(1)
	  xout(2)=calouttot(2)
c	  xout(3)=calouttot(21)
c	  xout(4)=calouttot(22)
c      read(8002,5000, end=60)yout, dagout, hout,(calouttot(ki), ki=1,22)
c	  xout(5)=calouttot(1)
c	  xout(6)=calouttot(2)
c	  xout(7)=calouttot(21)
c	  xout(8)=calouttot(22)
c      read(8003,5000, end=60)yout, dagout, hout,(calouttot(ki), ki=1,22)
c	  xout(9)=calouttot(1)
c	  xout(10)=calouttot(2)
c	  xout(11)=calouttot(21)
c	  xout(12)=calouttot(22)
c     read(8004,5000, end=60)yout, dagout, hout,(calouttot(ki), ki=1,22)
c	  xout(13)=calouttot(1)
c      read(8005,5000, end=60)yout, dagout, hout,(calouttot(ki), ki=1,22)
c	  xout(14)=calouttot(1)


	write(18019,5001) yout, dagout,(xout(ik),ik=1,2)
	  go to 47

60	continue
5000  format(1x,i4,2x,i3,1x,i2,22e10.3)
5001  format(1x,i4,2x,i3,22e10.3)
        return
        end
