	subroutine automet
      use parm
	
	integer iobj,isens		
c	open(19030, file='swatfilenames.prn')

	open (18010, file='changepar.dat')
	call telpar(nopt)
	rewind(18010)
      open(18016, file='objmet.dat')
	open(18017, file='responsmet.dat')
	call telobjresp(iobj,isens)	  
	rewind(18016)
	rewind(18017)
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c               BEGIN SENSITIVITY PART BY AVG
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        if (iclb.eq.1) then
      write(*,*) 'starting sensitivity analysis...'	
	write(*,*) ' written by Ann van Griensven'
	write(*,*) '         at University of California Riverside'

	call sensmain(nopt,iobj,isens)
    
      write(*,*) 'sensitivity analysis completed!'	
	end if	

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c               BEGIN OPTIMISATION AND UNCERTAINTY
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	  continue
        if (iclb.eq.2.or.iclb.eq.3) then
	write(*,*) ' starting PARASOL method...'
	write(*,*) ' written by Ann van Griensven'
	write(*,*) '         at University of California Riverside'
        call parasol(nopt,iobj,isens)
c       end autocalibration section
	write(*,*) 'PARASOL method completed!'

        end if



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c               BEGIN RERUN
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        if (iclb.eq.4) then
        write(*,*) 'RERUN best parameter file...'

      call rerunfile(nopt,iobj,isens)
c       end autocalibration section
        end if


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c               BEGIN BATCHRUN PART BY AVG
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
1003        if (iclb.eq.5) then
      write(*,*) 'rerun good parameter sets...'	
	write(*,*) ' written by Ann van Griensven'
	write(*,*) '         at University of California Riverside'
	call batchmain(nopt)
	write(*,*) 'Batchruns completed!'
	end if
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c              RERUN UNCERTAINTY LOOP BY AVG
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
1004	  continue
        if (iclb.eq.6) then
        write(*,*) 'rerun uncertainty analysis'
       call rerunPS(nopt,iobj,isens)
c       end autocalibration section
        end if

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        if (iclb.eq.8) then
        write(*,*) 'start sunglasses method'
!       call sunglasses(iclb,nopt)
        call sunglasses(nopt,iobj,isens)
        end if


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        if (iclb.eq.9) then
        write(*,*) 'rerun uncertainty analysis'
       call sunglasrerun(nopt,iobj,isens)
	        end if
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

	return 
	end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


       subroutine functn(xx,nopt, iiname, inrhru, iinr, icalml,iobj,
     *	 icalpar, isens, isenspar, sensw,obj, imet,icd)

      real*8 bbound(2,nopt), calw(iobj), sensw(isens), funcv, xx(nopt)
	real*8 obj(iobj)
	integer iinr(nopt), iiname(nopt), isens,iof, icalml
      integer inrhru(nopt,2000), iobj, imet(nopt)
      integer icalpar(4,iobj), nopt, isenspar(4,isens)
	character*7 swatfilen
	ipr=0
c
		write(18013, 8013) icalml, (xx(ii), ii=1,nopt)
8013    format(i5, 100e12.5)
      call rerun(xx, nopt,iiname, inrhru, iinr, icalml, imet,ipr)
      call objfunctn(obj, iobj, icalpar, icalml,icd)
	call response(senw, isens, isenspar, icalml)

c	read(19030, 7,end=9) swatfilen
c	open (18019,file=swatfilen)
c	call writeswatfile
c	close (18019)
9	continue
	
7	format(a7)
	return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!     !  !         !         !         !         !         !         ! !
      subroutine readchangepar(bbound,nopt,iiname,iinr, inrhru,imet,
     *	parname)
c
c   THIS SUBROUTINE READS AND PRINTS LIST OF PARAMTERS TO BE CHANGED

!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
      real*8 bbound(2,nopt)
      integer iinr(nopt), iiname(nopt), isens, imet(nopt)
      integer inrhru(nopt,2000), iobj, nintval, iseed
	character*10 parname(nopt), pname
      common /iopar/ in,iprii
c
c
c  INITIALIZE I/O VARIABLES
c
      bbound=0.

997   format(4i3, f8.3)	
	read(18010,*)
	


c
	write (iprii,*)'================================================='

      write(iprii,700)
  700 format(10x,'Parameter list of changepar.dat')
	write (iprii,*)'================================================='
      write(iprii,916)
  916 format(//,8x,'INITIAL PARAMETER VALUES AND PARAMETER BOUNDS',/,
     &       8x,45(1h=),//,2x,'PARAMETER',5x,'INITIAL VALUE',5x,
     &       'LOWER BOUND',5x,'UPPER BOUND',/,2x,9(1h-),5x,13(1h-),5x,
     &       11(1h-),5x,11(1h-))
c
c
c  READ THE INITIAL PARAMETER VALUES AND THE PARAMETER BOUNDS
	do iopt=1,nopt

      read(18010,830) bl1, bu2,in1, in2, in3, pname
	       write(iprii,832) iopt,bl1, bu2,in1, in2, in3, pname
       bbound(1,iopt)=bl1
       bbound(2,iopt)=bu2
       iiname(iopt)=in1
	 imet(iopt)=in2
       iinr(iopt)=in3
	 parname(iopt)=pname
       if (in3.eq.0) go to 5566
       if (in3.gt.2000) go to 5566
       read(18010,831) (inrhru(iopt,ii), ii=1,in3)
5566   continue	
111    format(2i5,a13)
  830 format(2f10.5,3i5, a10)
  832 format(i4,2f10.5,3i5, a10)
  831 format (50i5)
	end do
1918   format(2f10.5)
c
C  END OF SUBROUTINE SENSIN
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


c::::::::::::::
c telpar
c::::::::::::::

!     !  !         !         !         !         !         !         ! !
      subroutine telpar(nopt)

c
c	WRITTEN BY ANN VAN GRIENSVEN - UNIVERSITY OF CALIFORNIA, 2003
c
c

!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)

      integer it(2000)

      common /iopar/ in,iprii

c

c
c  INITIALIZE I/O VARIABLES

	read(18010,*)

c
      bbound=0.



c  READ THE INITIAL PARAMETER VALUES AND THE PARAMETER BOUNDS
      iopt = 0
  820 iopt = iopt + 1

      read(18010,830,end=840) bl1, bu2,in1, in2, in3

       if (in3.eq.0) go to 5566
       if (in3.gt.2000) go to 5566
       read(18010,831,end=840) (it(ii), ii=1,in3)
5566   continue	
111    format(2i5,a13)
  830 format(2f10.5,3i5)
  832 format(i4,2f10.5,3i5)
  831 format (50i5)
      go to 820
840   continue
      nopt=iopt-1
1918   format(2f10.5)

      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


!     !  !         !         !         !         !         !         ! !
      subroutine readmetfiles(iobj,calw, icalpar,isenspar,sensw,
     *	isens)
!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
      real*8 calw(iobj), sensw(isens)
      integer isens
      integer iobj
      integer icalpar(4,iobj), isenspar(4,isens)
	character*10 icalpar1(22), icalpar2(8), isenspar2(5)
	character*5 icalpar3a(22),icalpar3b(22)
      common /iopar/ in,iprii
 	data icalpar1/'flow      ','sediment  ','organic N ','organic P ',
     *'nitrate   ','ammonia   ','nitrite   ','mineral P ','CBOD      ',			
     *'oxygen    ','chl-a     ','sol pest  ','sor pest  ','perc bact ',			
     *'see manual','see manual','metal#2   ','metal#3   ','temperat  ',			
     *'kjel N    ','total N   ','total P   '/			

	data icalpar2/'SSQ       ','SSQ-log   ','SSQ-sqrt  ','          ',
     *'SSQR      ','          ','          ','BIAS      '/

	data isenspar2/'aver.','     ','          ','          ',
     *'          '/

	data icalpar3a/'m3/s ','mg/L ','mg/L ','mg/L ','mg/L ','mg/L '
     *,'mg/L ','mg/L ','mg/L ','mg/L ','ug/L ','mg/L ','mg/L '			
     *,'ct/L ','**** ','**** ','mg/L ','mg/L ','degC ','mg/L '			
     *,'mg/L ','mg/L '/
	data icalpar3b/'m3/s ','T/d  ','T/d  ','T/d  ','T/d  ','T/d  '
     *,'T/d  ','T/d  ','T/d  ','T/d  ','kg/d ','T/d  ','T/d  '			
     *,'Gct/d','*****','*****','T/d  ','T/d  ','heat ','T/d  '			
     *,'T/d  ','T/d  '/



c
c  READ THE OBJECTIVE FUNCTIONS CONTROL PARAMETERS

        do mm=1,iobj
!     !  !         !         !         !         !         !         ! !
      read(18016,997, end=996) icalpar(1,mm),icalpar(2,mm),icalpar(3,mm)
     *   ,icalpar(4,mm),calw(mm) 
        if (calw(mm).le.0.) calw(mm)=1.
        if (icalpar(1,mm).le.0) go to 996
        end do
996     continue
 	
        write(iprii,*) "Objective functions are (objmet.dat): "
        do mm = 1,iobj
	write(iprii,305) mm
305	format('OBJECTIVE FUNCTION', i3,' =')

	if (icalpar(1,mm).eq.1) then
		write(iprii,301) icalpar2(icalpar(2,mm)),
     *	icalpar1(icalpar(1,mm)),
     *   icalpar(4,mm)
	else
		if (icalpar(3,mm).eq.0) then
		write(iprii,302) icalpar2(icalpar(2,mm)),
     *	icalpar1(icalpar(1,mm)),
     *	icalpar3a(icalpar(1,mm)),
     *    icalpar(4,mm)
		else
		write(iprii,303) icalpar2(icalpar(2,mm)),
     *	icalpar1(icalpar(1,mm)),
     *	icalpar3b(icalpar(1,mm)),
     *    icalpar(4,mm)
		end if	
	end if
      end do


c
c
c  READ THE CONTROL PARAMETERS
      write (*,*) ' READING RESPONSE CONTROL PARAMETERS'

        do mm=1,isens
!     !  !         !         !         !         !         !         ! !
      read(18017,997, end=998) isenspar(1,mm),isenspar(2,mm),
     *   isenspar(3,mm),isenspar(4,mm),sensw(mm) 
        if (isenspar(1,mm).le.0) go to 998
        end do
998     continue
        write(iprii,*) "Response functions are (responsmet.dat): "
        do mm = 1,isens
	write(iprii,300) mm
300	format('OUTPUT ',i3,' =')

	if (isenspar(1,mm).eq.1) then
		write(iprii,301) isenspar2(isenspar(2,mm)),
     *	icalpar1(isenspar(1,mm)),isenspar(4,mm)
301   format(a5,' for ',a10,'       (m^3/s)',' at location',i3)
	else
		if (isenspar(3,mm).eq.0) then
		write(iprii,302) isenspar2(isenspar(2,mm)),
     *	icalpar1(isenspar(1,mm)),
     *	icalpar3a(isenspar(1,mm)),
     *   isenspar(4,mm)
302   format(a5,' for ',a10,' conc.',' (',a5,')',' at location',i3)
		else
		write(iprii,303) isenspar2(isenspar(2,mm)),
     *	icalpar1(isenspar(1,mm)),
     *	icalpar3b(isenspar(1,mm)),
     *   isenspar(4,mm)
303   format(a5,' for ',a10,' load ',' (',a5,')',' at location',i3)
		end if	
	end if
       end do


997   format(4i3, f8.3)	



      return
      end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc



!     !  !         !         !         !         !         !         ! !
      subroutine telobjresp(iobj,isens)
!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)

      integer isens
      integer iobj
      integer irde(4)
		



c
c  READ THE OBJECTIVE FUNCTIONS CONTROL PARAMETERS

        do mm=1,100
!     !  !         !         !         !         !         !         ! !
      read(18016,997, end=996) (irde(ii),ii=1,4),clw 
        if (irde(1).le.0) go to 996
        end do
996     continue
        iobj=mm-1
	


        do mm=1,100
!     !  !         !         !         !         !         !         ! !
      read(18017,997, end=998) (irde(ii),ii=1,4),clw 
        if (irde(1).le.0) go to 998
        end do
998     continue
        isens=mm-1

997   format(4i3, f8.3)	



      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc