      subroutine sensmain(nopt,iobj,isens)
!     !  !         !         !         !         !         !         ! !
c	Main program for the sensitivity analysis

!!    iobj         |none          |number of objective functions
!!    obj(:)       |none          |values of the objective functions
!!    iclb         |none          |method to form GOC out of objective functions
!!    icalpar(:,:) |none          |objective functions codes of CALMET.DAT
!!    iitel        |none          |number of simulation run
!!    iinr(:)      !              |number of HRUs to change for parameter (:)
!!    inrhru(:,:)  |none          |list of HRU numbers to change  

c     AVG

!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
	real*8 bbound(2,nopt), calw(iobj), sensw(isens),dt, xxo(nopt)
	real*8 obj(iobj)
      integer iinr(nopt), iiname(nopt), isens, iobj, iitel,m
      integer inrhru(nopt,2000), nintval, iseed, imet(nopt)
      integer icalpar(4,iobj), nopt, isenspar(4,isens)
	character*10 parname(nopt)
      common /iopar/ in,iprii
c
	
      in = 18009
      iprii = 18011
	ipr=0
      open(unit=in,file='sensin.dat',status='old')
      open(unit=iprii,file='sensout.out',status='unknown')
      open(18012, file='sensobjf.out')
      open(18013, file='senspar.out')
	open(18014, file='sensrespons.out')
      open(18015, file='sensresult.out')
	open(18018, file='lathyppar.out')
	open(18019, file='oatpar.out')
	
	call sensin(dt,nintval,iseed)
	call readmetfiles(iobj,calw, icalpar,isenspar,sensw,
     *	isens)
	call readchangepar(bbound,nopt,iiname,iinr, inrhru,imet,parname)
	write(18015,1815) (parname(kk), kk=1,nopt)
1815  format(13x,100a10)
c	go to 4
	call sample(nopt,nintval,iseed, bbound,dt)
	write (*,*)
	write (*,*) 'WARNING: the program will run ',nintval*(nopt+1),
     * ' times!!!'
      write (*,*)	
	icd=0

	iitel=0
	rewind(18013)

5      read (18013,8013, end =4) i, (xxo(ii), ii=1,nopt)
8013    format(i5, 100e12.5)
       iitel=iitel+1
	call rerun(xxo, nopt,iiname, inrhru, iinr, iitel,imet,ipr)
      call objfunctn(obj, iobj, icalpar, iitel,icd)
	if (isens.gt.0) call response(sensw, isens, isenspar, iitel)
	go to 5
4	continue	
	call analyse(nintval,nopt,iobj,isens, parname)
	close(in)
      close(iprii)
      close(18012)
      close(18013)
	close(18014)
      close(18015)
      close(18016)
	close(18017)
	close(18018)
	close(18019)

c  END OF THE MAIN PROGRAM
      return
	end
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c::::::::::::::
c sensin.f
c::::::::::::::

!     !  !         !         !         !         !         !         ! !
      subroutine sensin(dt,nintval,iseed)
!     !  !         !         !         !         !         !         ! !
      implicit real*8 (a-h,o-z)
	integer nintval, iseed

      common /iopar/ in,iprii

c
      write (*,*) ' ENTER THE SENSITIVITY ANALYSIS SUBROUTINE --- '
c
c
c  INITIALIZE I/O VARIABLES



c
	write (iprii,*)'================================================='

      write(iprii,700)
  700 format(10x,'sensitivity analysis inputs and results')
	write (iprii,*)'================================================='

      read(in,*) nintval
	read(in,*) dt
	read(in,*) iseed
	
      if (iseed .eq. 0) iseed = 1969
	if (dt .le. 0.or.dt.gt.0.5) dt = 1./nintval/2.
	write (iprii,*)'================================================='
	write (iprii,*)'Control parameter are :'		 
	write (iprii,*) 'number of intervals in Latin Hypercube = ',
     *	 nintval
	write (iprii,*) ' parameter change for OAT  = ', dt
	write (iprii,*) ' random seed number = ', iseed
	write (iprii,*)'================================================='

c
C  END OF SUBROUTINE SENSIN
      return
      end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine  sample(ip,m,iseed, bbound,dt)



c	Latin Hypercube sampling program
c	Written by Ann van Griensven at UC Riverside
c
c
c	ip = number of parameters
c     m  = number of intervals
c	X= matrix with ip parameter values for m samples
c	IX stores positions within hypercube intervals	
c
c
c
	real*8 x(m,ip), bbound(2,200),dt
	integer ix(m,ip), ip, m, iseed
	integer isample(m)
	write (*,*) 'starting sampling	 ....'

	do ii=1,ip
	call sample1(isample,m,iseed)	
	do jj=1,m
	ix(jj,ii)=isample(jj)
	x(jj,ii)=(isample(jj)-1.+ran(iseed))/m
	end do
	end do
	do jj=1,m
	write(18018,1) isample(jj),(x(jj,kk), kk=1,ip)
1	format(i4,100f12.5)
	end do

	call oat(x,m,ip, bbound,dt,iseed)
	return
	end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	
	subroutine sample1(isample,k,iseed)
	

c	This subroutine samples a sequence of m integers without repetition. 
	integer iseed, isample, k
	
	dimension isample(k)
	dimension ihelp(k)

	ihelp=0
	do ii=1,k
	n=k-ii+1
	isamp=1.+int(n*ran(iseed))
	jj=1
	jk=1
	iisamp=isamp
	do while (jj<=iisamp)
	if (ihelp(jk).eq.0)then 
	jj=jj+1
	else
	isamp=isamp+1
	end if
	jk=jk+1
	end do
	ihelp(isamp)=1
	isample(ii)=isamp
	end do
	return
	end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	
	subroutine oat(x,m,ip,bbound,dt,iseed)
c	This subroutine perfoms One-factor-At-a-Time desing

	
	real*8 X(m,ip), yy(ip+1, ip),dt, bbound(2,200), yp(ip)
	integer isample(ip), iseed
	itel=0
	zero=0
	do nloop=1, m
	write (18019,*) 'loop', nloop

	do ii=1,ip
	yy(1,ii) = x(nloop,ii)
	end do
	jj=1
	write(18019,1) jj,zero, (yy(1,kk), kk=1,ip)
	do ii=1,ip
	yp(ii)= bbound(1,ii)+(bbound(2,ii)-bbound(1,ii))*yy(1,ii)
	end do
	itel=itel+1
	write(18013,8013) itel,(yp(kk), kk=1,ip)
	call sample1(isample,ip,iseed)
	
	do jj=2,ip+1
	do ii=1,ip
	yy(jj,ii)=yy(jj-1,ii)
	end do
	if (ran(iseed).gt.0.5) then
	t=1.
	else
	t=-1.
	end if
	zz=yy(jj,isample(jj-1))+dt*t
	if (zz.lt.0.or.zz.gt.1) zz=yy(jj,isample(jj-1)) - dt*t
	yy(jj,isample(jj-1))=zz
	write(18019,1) jj,isample(jj-1), (yy(jj,kk), kk=1,ip)
	do kk=1,ip
		yp(kk)= bbound(1,kk)+(bbound(2,kk)-bbound(1,kk))*yy(jj,kk)
	end do
	itel=itel+1
	write(18013,8013) itel, (yp(kk), kk=1,ip)
	end do
	end do

1	format(2i4,200e12.5)
8013   format(i5, 100e12.5)
	return
	end 

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
	subroutine analyse(nintval,nopt,iobj,isens, parname)
	integer nintval,nopt,isamp,iobj,isens, ira(nopt), irank(nopt)
	real*8 xx(nopt), lhx(nintval,nopt), lhy(nintval)
	real*8 yobj(nintval,max(iobj,isens)),help(nopt)	
	real*8 oatobj(nintval,nopt,max(iobj,isens)),
     *	oatmax(nopt,max(iobj,isens)), help1(nopt)
	real*8 yy(max(iobj,isens)),yhelp(max(iobj,isens)),rank(nopt)
      character*10 parname(nopt)
	common /iopar/ in,iprii

	


c	AOT SENSITIVITY ANALYSING  ON OBJECTIVE FUNTCTIONS

	if (iobj.gt.0) then
	write (iprii,*)'AOT sensitivity analyses on objective functions '
	rewind(18019)
	rewind(18012)
	do iloop=1,nintval
		read(18019,*)
		read(18019,1) itel, ipar, (xx(kk), kk=1,nopt)
		read(18012,2) itel,(yy(kk),kk=1,iobj)

		do kk=1,nopt
		lhx(iloop,kk)=xx(kk)
		end do

		do kk=1,iobj
		yobj(iloop,kk)=yy(kk)
		end do
		do jj=1,nopt
		read(18019,1) itel, ipar, (xx(kk), kk=1,nopt)
				yhelp=yy			
   		read(18012,2) itel,(yy(kk),kk=1,iobj)

			do kk=1,iobj
		t=yy(kk)-yhelp(kk)
				oatobj(iloop,ipar,kk)=0.
			if (abs(t).gt.0) oatobj(iloop,ipar,kk)=abs(t)*50./
     *	(yhelp(kk)+yy(kk))
			end do
			end do
	end do
	oatmax=maxval(oatobj,dim=1)

	do ik=1,iobj
	write (iprii,*) 'OBJECTIVE FUNCTION ', ik
	write (iprii,*) 'results per loop '
		help=0.
		help1=0.
		do jk=1,nintval
		write (iprii,3) jk,(oatobj(jk,kk,ik),kk=1,nopt)
		do kk=1,nopt
		help(kk)=help(kk)+oatobj(jk,kk,ik)
		end do
		end do
		do kk=1,nopt
		help(kk)=help(kk)/nintval
		end do
		
		do jk=1,nintval
		do kk=1,nopt
		help1(kk)=help1(kk)+(help(kk)-oatobj(jk,kk,ik))**2
		end do
		end do	
		
		do kk=1,nopt
		help1(kk)=help1(kk)/(nintval-1)
		end do

	write (iprii,*) '-----------------------------------------------'	
	write (iprii,*) ' maximum '
	write (iprii,4) (oatmax(kk,ik), kk=1,nopt)
	write (iprii,*) ' variance '
	write (iprii,4) (help1(kk), kk=1,nopt)
	write (iprii,*) '-----------------------------------------------'	
	write (iprii,*) ' mean '
	write (iprii,4) (help(kk), kk=1,nopt)

	call sorteer3(help,rank,nopt,irank,ira)
	do ii=1,nopt
	if (rank(ii).eq.0.) ira(ii)=nopt+1
	if (help(ii).eq.0.)  irank(ii)=nopt+1
	end do
	write (iprii,*) ' ranking '
	write(18015,55) ik, (irank(kk), kk=1,nopt)
	write (iprii,5) (irank(kk), kk=1,nopt)
	write (iprii,*) '------------------------------------------------'

	write (iprii,*) '------------------------------------------------'
	write (iprii,*) ' parname   rank      mean  '
	do ii=1,nopt
	write (iprii,8) parname(ii), irank(ii),help(ii)
8	format(a10,i5,e12.3)
	end do

	end do


c	AOT SENSTIVITY ANALYSING ON OUTPUT VALUES
	end if

	if (isens.gt.0) then
	write (iprii,*)'AOT sensitivity analyses on objective functions '
	rewind(18019)
	rewind(18014)
	do iloop=1,nintval
		read(18019,*)
		read(18019,1) itel, ipar, (xx(kk), kk=1,nopt)
		read(18014,2) itel,(yy(kk),kk=1,isens)
		do kk=1,nopt
		lhx(iloop,kk)=xx(kk)
		end do
		do kk=1,isens
		yobj(iloop,kk)=yy(kk)
		end do
	
			do jj=1,nopt
			read(18019,1) itel, ipar, (xx(kk), kk=1,nopt)
			yhelp=yy				
   			read(18014,2) itel,(yy(kk),kk=1,isens)
			do kk=1,isens
		t=yy(kk)-yhelp(kk)
				oatobj(iloop,ipar,kk)=0.
			if (abs(t).gt.0) oatobj(iloop,ipar,kk)=abs(t)*50./
     *	(yhelp(kk)+yy(kk))
			end do
			end do
	end do
	oatmax=maxval(oatobj,dim=1)

	do ik=1,isens
	write (iprii,*) 'OUTPUT VALUE ', ik
	write (iprii,*) 'results per loop '
		help=0.
		help1=0.
		do jk=1,nintval
		write (iprii,3) jk,(oatobj(jk,kk,ik),kk=1,nopt)
		do kk=1,nopt
		help(kk)=help(kk)+oatobj(jk,kk,ik)
		end do
		end do

		do kk=1,nopt
		help(kk)=help(kk)/nintval
		end do
		
		do jk=1,nintval
		do kk=1,nopt
		help1(kk)=help1(kk)+(help(kk)-oatobj(jk,kk,ik))**2
		end do
		end do	
		
		do kk=1,nopt
		help1(kk)=help1(kk)/(nintval-1)
		end do

	write (iprii,*) '-----------------------------------------------'	
	write (iprii,*) ' maximum '
	write (iprii,4) (oatmax(kk,ik), kk=1,nopt)
	write (iprii,*) ' variance '
	write (iprii,4) (help1(kk), kk=1,nopt)
	write (iprii,*) '-----------------------------------------------'	
	write (iprii,*) ' mean '
	write (iprii,4) (help(kk), kk=1,nopt)

	call sorteer3(help,rank,nopt,irank,ira)
	do ii=1,nopt
	if (rank(ii).eq.0.) ira(ii)=nopt+1
	if (help(ii).eq.0.)  irank(ii)=nopt+1
	end do
	write(18015,56) ik, (irank(kk), kk=1,nopt)
	write (iprii,*) ' ranking '
	write (iprii,5) (irank(kk), kk=1,nopt)
	write (iprii,*) '------------------------------------------------'

	write (iprii,*) '------------------------------------------------'
	write (iprii,*) '      par #     mean  '
	do ii=1,nopt
	write (iprii,8) parname(ii), irank(ii),help(ii)
	end do

	end do
	end if

c	AOT SENSTIVITY ANALYSING ON OUTPUT VALUES
55	format('of ',i3,'|',100i10)
56	format('out',i3,'|',100i10)
5	format (200i12)
4	format(4x,200e12.5)					
3	format(i4,200e12.5)
1	format(2i4,200f12.5)
2	format(i5,200e12.5)
6	format(20e13.3)
	return
	end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine sorteer3(ari, arr,len,irank,ira)
        integer len, ira(len), irank(len)
	  real*8 arr(len),ari(len), help1, help2
	
	arr=ari
	  lenn=len
	  do ii=1,len
	  ira(ii)=ii
	  end do
        do ii=1,len
         lenn=lenn-1
         help1=arr(1)
          do jj=1,lenn
            help1=arr(jj)
            help2=arr(jj+1)
            if (help2.gt.help1) then
            arr(jj)=help2
            arr(jj+1)=help1
		  it=ira(jj)			
	      ira(jj)=ira(jj+1)
	      ira(jj+1)=it
          end if
          end do
          end do

		do ii=1,len 
		irank(ira(ii))=ii
	    END DO
         return
         end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
